'use strict';

exports.__esModule = true;

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _runtime = require('../../errors/runtime');

var _message = require('../../errors/runtime/message');

var _message2 = _interopRequireDefault(_message);

var _wrapTestFunction = require('./wrap-test-function');

var _wrapTestFunction2 = _interopRequireDefault(_wrapTestFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Test = function Test(name, fn, fixture) {
    (0, _classCallCheck3.default)(this, Test);

    var nameType = typeof name === 'undefined' ? 'undefined' : (0, _typeof3.default)(name);

    if (nameType !== 'string') throw new _runtime.APIError('test', _message2.default.testNameIsNotAString, nameType);

    var fnType = typeof fn === 'undefined' ? 'undefined' : (0, _typeof3.default)(fn);

    if (fnType !== 'function') throw new _runtime.APIError('test', _message2.default.testBodyIsNotAFunction, fnType);

    this.name = name;
    this.fixture = fixture;
    this.fn = (0, _wrapTestFunction2.default)(fn);
};

exports.default = Test;
module.exports = exports['default'];