'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _testcafeBrowserTools = require('testcafe-browser-tools');

var _testcafeBrowserTools2 = _interopRequireDefault(_testcafeBrowserTools);

var _osFamily = require('os-family');

var _osFamily2 = _interopRequireDefault(_osFamily);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PathBrowserProvider = function (_BrowserProviderBase) {
    (0, _inherits3.default)(PathBrowserProvider, _BrowserProviderBase);

    function PathBrowserProvider() {
        (0, _classCallCheck3.default)(this, PathBrowserProvider);

        var _this = (0, _possibleConstructorReturn3.default)(this, _BrowserProviderBase.call(this));

        _this.isMultiBrowser = true;
        return _this;
    }

    PathBrowserProvider.prototype._handleJSON = function () {
        var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(str) {
            var params, openParameters;
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            params = null;
                            _context.prev = 1;

                            params = JSON.parse(str);
                            _context.next = 8;
                            break;

                        case 5:
                            _context.prev = 5;
                            _context.t0 = _context['catch'](1);
                            return _context.abrupt('return', null);

                        case 8:
                            if (params.path) {
                                _context.next = 10;
                                break;
                            }

                            return _context.abrupt('return', null);

                        case 10:
                            _context.next = 12;
                            return _testcafeBrowserTools2.default.getBrowserInfo(params.path);

                        case 12:
                            openParameters = _context.sent;

                            if (openParameters) {
                                _context.next = 15;
                                break;
                            }

                            return _context.abrupt('return', null);

                        case 15:

                            if (params.cmd) openParameters.cmd = params.cmd;

                            return _context.abrupt('return', openParameters);

                        case 17:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, this, [[1, 5]]);
        }));

        function _handleJSON(_x) {
            return _ref.apply(this, arguments);
        }

        return _handleJSON;
    }();

    PathBrowserProvider.prototype.openBrowser = function () {
        var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(browserId, pageUrl, browserName) {
            var openParameters;
            return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            _context2.next = 2;
                            return _testcafeBrowserTools2.default.getBrowserInfo(browserName);

                        case 2:
                            _context2.t0 = _context2.sent;

                            if (_context2.t0) {
                                _context2.next = 7;
                                break;
                            }

                            _context2.next = 6;
                            return this._handleJSON(browserName);

                        case 6:
                            _context2.t0 = _context2.sent;

                        case 7:
                            openParameters = _context2.t0;

                            if (openParameters) {
                                _context2.next = 10;
                                break;
                            }

                            throw new Error('The specified browser name is not valid!');

                        case 10:
                            _context2.next = 12;
                            return _testcafeBrowserTools2.default.open(openParameters, pageUrl);

                        case 12:
                            if (!_osFamily2.default.win) {
                                _context2.next = 15;
                                break;
                            }

                            _context2.next = 15;
                            return _BrowserProviderBase.prototype.calculateResizeCorrections.call(this, browserId);

                        case 15:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, _callee2, this);
        }));

        function openBrowser(_x2, _x3, _x4) {
            return _ref2.apply(this, arguments);
        }

        return openBrowser;
    }();

    PathBrowserProvider.prototype.closeBrowser = function () {
        var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(browserId) {
            return _regenerator2.default.wrap(function _callee3$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                        case 0:
                            _context3.next = 2;
                            return _testcafeBrowserTools2.default.close(browserId);

                        case 2:
                        case 'end':
                            return _context3.stop();
                    }
                }
            }, _callee3, this);
        }));

        function closeBrowser(_x5) {
            return _ref3.apply(this, arguments);
        }

        return closeBrowser;
    }();

    PathBrowserProvider.prototype.getBrowserList = function () {
        var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
            return _regenerator2.default.wrap(function _callee4$(_context4) {
                while (1) {
                    switch (_context4.prev = _context4.next) {
                        case 0:
                            return _context4.abrupt('return', ['${PATH_TO_BROWSER_EXECUTABLE}']);

                        case 1:
                        case 'end':
                            return _context4.stop();
                    }
                }
            }, _callee4, this);
        }));

        function getBrowserList() {
            return _ref4.apply(this, arguments);
        }

        return getBrowserList;
    }();

    return PathBrowserProvider;
}(_base2.default);

exports.default = PathBrowserProvider;
module.exports = exports['default'];