'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

var _osFamily = require('os-family');

var _osFamily2 = _interopRequireDefault(_osFamily);

var _message = require('../../../warnings/message');

var _message2 = _interopRequireDefault(_message);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RemoteBrowserProvider = function (_BrowserProviderBase) {
    (0, _inherits3.default)(RemoteBrowserProvider, _BrowserProviderBase);

    function RemoteBrowserProvider() {
        (0, _classCallCheck3.default)(this, RemoteBrowserProvider);

        // NOTE: This can be used to disable resize correction when running unit tests.
        var _this = (0, _possibleConstructorReturn3.default)(this, _BrowserProviderBase.call(this));

        _this.disableResizeHack = false;
        return _this;
    }

    RemoteBrowserProvider.prototype.openBrowser = function () {
        var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(browserId) {
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            _context.prev = 0;

                            if (!(_osFamily2.default.win && !this.disableResizeHack)) {
                                _context.next = 4;
                                break;
                            }

                            _context.next = 4;
                            return _BrowserProviderBase.prototype.calculateResizeCorrections.call(this, browserId);

                        case 4:
                            _context.next = 9;
                            break;

                        case 6:
                            _context.prev = 6;
                            _context.t0 = _context['catch'](0);
                            return _context.abrupt('return');

                        case 9:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, this, [[0, 6]]);
        }));

        function openBrowser(_x) {
            return _ref.apply(this, arguments);
        }

        return openBrowser;
    }();

    RemoteBrowserProvider.prototype.closeBrowser = function () {
        var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
            return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            return _context2.abrupt('return');

                        case 1:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, _callee2, this);
        }));

        function closeBrowser() {
            return _ref2.apply(this, arguments);
        }

        return closeBrowser;
    }();

    // NOTE: we must try to do a local screenshot or resize, if browser is accessible, but emit warning


    RemoteBrowserProvider.prototype.takeScreenshot = function () {
        var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(browserId) {
            var _BrowserProviderBase$,
                _len,
                args,
                _key,
                _args3 = arguments;

            return _regenerator2.default.wrap(function _callee3$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                        case 0:
                            _context3.prev = 0;

                            for (_len = _args3.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                                args[_key - 1] = _args3[_key];
                            }

                            _context3.next = 4;
                            return (_BrowserProviderBase$ = _BrowserProviderBase.prototype.takeScreenshot).call.apply(_BrowserProviderBase$, [this, browserId].concat(args));

                        case 4:
                            _context3.next = 9;
                            break;

                        case 6:
                            _context3.prev = 6;
                            _context3.t0 = _context3['catch'](0);

                            this.reportWarning(browserId, _message2.default.browserManipulationsOnRemoteBrowser);

                        case 9:
                        case 'end':
                            return _context3.stop();
                    }
                }
            }, _callee3, this, [[0, 6]]);
        }));

        function takeScreenshot(_x2, _x3) {
            return _ref3.apply(this, arguments);
        }

        return takeScreenshot;
    }();

    RemoteBrowserProvider.prototype.resizeWindow = function () {
        var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(browserId) {
            var _BrowserProviderBase$2,
                _len2,
                args,
                _key2,
                _args4 = arguments;

            return _regenerator2.default.wrap(function _callee4$(_context4) {
                while (1) {
                    switch (_context4.prev = _context4.next) {
                        case 0:
                            _context4.prev = 0;

                            for (_len2 = _args4.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                                args[_key2 - 1] = _args4[_key2];
                            }

                            _context4.next = 4;
                            return (_BrowserProviderBase$2 = _BrowserProviderBase.prototype.resizeWindow).call.apply(_BrowserProviderBase$2, [this, browserId].concat(args));

                        case 4:
                            _context4.next = 9;
                            break;

                        case 6:
                            _context4.prev = 6;
                            _context4.t0 = _context4['catch'](0);

                            this.reportWarning(browserId, _message2.default.browserManipulationsOnRemoteBrowser);

                        case 9:
                        case 'end':
                            return _context4.stop();
                    }
                }
            }, _callee4, this, [[0, 6]]);
        }));

        function resizeWindow(_x4, _x5) {
            return _ref4.apply(this, arguments);
        }

        return resizeWindow;
    }();

    return RemoteBrowserProvider;
}(_base2.default);

exports.default = RemoteBrowserProvider;
module.exports = exports['default'];